'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = init;

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _uberproto = require('uberproto');

var _uberproto2 = _interopRequireDefault(_uberproto);

var _nodemailer = require('nodemailer');

var _nodemailer2 = _interopRequireDefault(_nodemailer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// import errors from 'feathers-errors';

var debug = (0, _debug2.default)('feathers-mailer');

var Service = function () {
  function Service(transport, defaults) {
    _classCallCheck(this, Service);

    debug('constructor', transport);

    if (!transport) {
      throw new Error('feathers-mailer: constructor `transport` must be provided');
    }

    this.transporter = _nodemailer2.default.createTransport(transport, defaults);
  }

  _createClass(Service, [{
    key: 'extend',
    value: function extend(obj) {
      return _uberproto2.default.extend(obj, this);
    }
  }, {
    key: 'create',
    value: function create(body, params, cb) {
      debug('create', body, params);

      // TODO maybe body should be text/html field
      // and params is rest of options

      // https://github.com/nodemailer/nodemailer#set-up-smtp says:
      // If callback argument is not set then the method returns a Promise object.
      return this.transporter.sendMail(body);
    }
  }]);

  return Service;
}();

function init(transport, defaults) {
  return new Service(transport, defaults);
}

init.Service = Service;
module.exports = exports['default'];